package myai;

/**
 * GarnetのNormal対戦用AI
 * 最強低空ハメコンボが決まれば100%勝てる。決まらなくてもまあまあ強い
 * @author Eita Aoki
 */
import java.util.LinkedList;

import enumerate.Action;
import enumerate.State;
import myutil.My;
import struct.GameData;

public class GarnetNormalAI extends MyAI {

	public GarnetNormalAI(GameData arg0, boolean player) {
		super(arg0, player);
		System.out.println("GarnetNormalAI");

	}

	// 使いたいActionの全量
	void setRootActions() {
		this.actionGround = My.actionGroundNonEnergy;
		this.actionAir = My.actionAirNonEnergy;

	}

	@Override
	public Action getPrepareAction() {

		Action tac = null;
		if (bestac != null) {
			LinkedList<Action> moveActs = calc.getEnoughEnergyActions(false, Action.NEUTRAL, Action.STAND_D_DF_FA,
					Action.STAND_D_DF_FB);
			if (my.getState() != State.AIR) {

				if (calc.getMinHpScore(tac = Action.STAND_B, moveActs) > 0) {
					return (tac);
				}
				// if( calc.getMinHpScore(tac=Action.CROUCH_FB,moveActs)>0){
				// return(tac);//sppedモードの時はないほうがいい
				// }
				if (calc.getMinHpScore(tac = Action.STAND_D_DB_BA, moveActs) > 0) {
					return (tac);
				}

				// else
				// if(calc.getMinHpScore(tac=Action.STAND_D_DF_FC,moveActs)>0){
				// return(tac);
				// }
				// if(calc.getMinHpScore(tac=Action.STAND_D_DB_BB,moveActs)>0){
				// return(tac);
				// }
				// else
				// if(calc.getMinHpScore(tac=Action.STAND_F_D_DFA,moveActs)>0){
				// return(tac);
				// }
				// if(calc.getHpScore(tac=Action.STAND_B)>0){
				// return(tac);
				// }
				// else if(calc.getHpScore(tac=Action.CROUCH_FB)>0){
				// return(tac);//sppedモードの時はないほうがいい
				// }
				// else if(calc.getHpScore(tac=Action.STAND_D_DF_FC)>0){
				// return(tac);
				// }
				// else if(calc.getHpScore(tac=Action.STAND_D_DB_BB)>0){
				// return(tac);
				// }
				// else if(calc.getHpScore(tac=Action.STAND_F_D_DFA)>0){
				// return(tac);
				// }
				if (calc.getMinHpScore(bestac, moveActs) > 0) {
					return (bestac);
				}

				// return(bestac);
				return mctsprocessing(simFrameData, HittingMyActions);

			} else {
				if (calc.getMinHpScore(tac = Action.AIR_UB, moveActs) > 0) {
					/*
					 * はいプロ 世界一ハメ技が得意 ハメ技界のtourist フェアプレー時代の終焉を告げる技 実質勝ち
					 * ハメ技するために生まれてきた技
					 */
					return (tac);
				}
				// return(bestac);
				return mctsprocessing(simFrameData, HittingMyActions);

			}
		} else {

			if (my.getState() != State.AIR) {

				if (my.getHp() - opp.getHp() > 10) {
					LinkedList<Action> moveActs = calc.getEnoughEnergyActions(true, Action.BACK_STEP, Action.JUMP,
							Action.FOR_JUMP, Action.FORWARD_WALK, Action.BACK_JUMP);

					return (calc.getMinMaxIfHadouken(moveActs));
				} else {
					LinkedList<Action> moveActs = (distance < 300)
							? calc.getEnoughEnergyActions(true, Action.FOR_JUMP, Action.FORWARD_WALK, Action.JUMP,
									Action.BACK_JUMP, Action.BACK_STEP)
							: calc.getEnoughEnergyActions(true, Action.FORWARD_WALK, Action.FOR_JUMP, Action.JUMP,
									Action.BACK_JUMP, Action.BACK_STEP);

					return (calc.getMinMaxIfHadouken(moveActs));

				}

			} else {
				return Action.AIR_GUARD;
			}
		}

	}

}
